/** CTriaxialEllipsoidModel
 *
 * C extension 
 *
 * WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
 *          DO NOT MODIFY THIS FILE, MODIFY triaxial_ellipsoid.h
 *          AND RE-RUN THE GENERATOR SCRIPT
 *
 * @author   M.Doucet / UTK
 */
 
#include <Python.h>
#include "structmember.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "triaxial_ellipsoid.h"

/// Error object for raised exceptions
static PyObject * CTriaxialEllipsoidModelError = NULL;


// Class definition
typedef struct {
    PyObject_HEAD
    /// Parameters
    PyObject * params;
    /// Log for unit testing
    PyObject * log;
    /// Model parameters
	TriaxialEllipsoidParameters model_pars;
} CTriaxialEllipsoidModel;


static void
CTriaxialEllipsoidModel_dealloc(CTriaxialEllipsoidModel* self)
{
    self->ob_type->tp_free((PyObject*)self);
    

}

static PyObject *
CTriaxialEllipsoidModel_new(PyTypeObject *type, PyObject *args, PyObject *kwds)
{
    CTriaxialEllipsoidModel *self;
    
    self = (CTriaxialEllipsoidModel *)type->tp_alloc(type, 0);
   
    return (PyObject *)self;
}

static int
CTriaxialEllipsoidModel_init(CTriaxialEllipsoidModel *self, PyObject *args, PyObject *kwds)
{
    if (self != NULL) {
    	
    	// Create parameters
        self->params = PyDict_New();
        
        // Initialize parameter dictionary
        PyDict_SetItemString(self->params,"scale",Py_BuildValue("d",1.000000));
        PyDict_SetItemString(self->params,"axis_psi",Py_BuildValue("d",0.000000));
        PyDict_SetItemString(self->params,"axis_theta",Py_BuildValue("d",1.000000));
        PyDict_SetItemString(self->params,"semi_axisA",Py_BuildValue("d",35.000000));
        PyDict_SetItemString(self->params,"semi_axisB",Py_BuildValue("d",100.000000));
        PyDict_SetItemString(self->params,"semi_axisC",Py_BuildValue("d",400.000000));
        PyDict_SetItemString(self->params,"axis_phi",Py_BuildValue("d",1.000000));
        PyDict_SetItemString(self->params,"background",Py_BuildValue("d",0.000000));
        PyDict_SetItemString(self->params,"contrast",Py_BuildValue("d",0.000005));

         
        // Create empty log
        self->log = PyDict_New();
        
        

    }
    return 0;
}

static PyMemberDef CTriaxialEllipsoidModel_members[] = {
    {"params", T_OBJECT, offsetof(CTriaxialEllipsoidModel, params), 0,
     "Parameters"},
    {"log", T_OBJECT, offsetof(CTriaxialEllipsoidModel, log), 0,
     "Log"},
    {NULL}  /* Sentinel */
};

/** Read double from PyObject
    @param p PyObject
    @return double
*/
double CTriaxialEllipsoidModel_readDouble(PyObject *p) {
    if (PyFloat_Check(p)==1) {
        return (double)(((PyFloatObject *)(p))->ob_fval);
    } else if (PyInt_Check(p)==1) {
        return (double)(((PyIntObject *)(p))->ob_ival);
    } else if (PyLong_Check(p)==1) {
        return (double)PyLong_AsLong(p);
    } else {
        return 0.0;
    }
}


/**
 * Function to call to evaluate model
 * @param args: input q or [q,phi]
 * @return: function value
 */
static PyObject * run(CTriaxialEllipsoidModel *self, PyObject *args) {
	double q_value, phi_value;
	PyObject* pars;
	int npars;
	
	// Get parameters
	
	// Reader parameter dictionary
    self->model_pars.scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
    self->model_pars.axis_psi = PyFloat_AsDouble( PyDict_GetItemString(self->params, "axis_psi") );
    self->model_pars.axis_theta = PyFloat_AsDouble( PyDict_GetItemString(self->params, "axis_theta") );
    self->model_pars.semi_axisA = PyFloat_AsDouble( PyDict_GetItemString(self->params, "semi_axisA") );
    self->model_pars.semi_axisB = PyFloat_AsDouble( PyDict_GetItemString(self->params, "semi_axisB") );
    self->model_pars.semi_axisC = PyFloat_AsDouble( PyDict_GetItemString(self->params, "semi_axisC") );
    self->model_pars.axis_phi = PyFloat_AsDouble( PyDict_GetItemString(self->params, "axis_phi") );
    self->model_pars.background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
    self->model_pars.contrast = PyFloat_AsDouble( PyDict_GetItemString(self->params, "contrast") );

	
	// Get input and determine whether we have to supply a 1D or 2D return value.
	if ( !PyArg_ParseTuple(args,"O",&pars) ) {
	    PyErr_SetString(CTriaxialEllipsoidModelError, 
	    	"CTriaxialEllipsoidModel.run expects a q value.");
		return NULL;
	}
	  
	// Check params
	if( PyList_Check(pars)==1) {
		
		// Length of list should be 2 for I(q,phi)
	    npars = PyList_GET_SIZE(pars); 
	    if(npars!=2) {
	    	PyErr_SetString(CTriaxialEllipsoidModelError, 
	    		"CTriaxialEllipsoidModel.run expects a double or a list of dimension 2.");
	    	return NULL;
	    }
	    // We have a vector q, get the q and phi values at which
	    // to evaluate I(q,phi)
	    q_value = CTriaxialEllipsoidModel_readDouble(PyList_GET_ITEM(pars,0));
	    phi_value = CTriaxialEllipsoidModel_readDouble(PyList_GET_ITEM(pars,1));
	    // Skip zero
	    if (q_value==0) {
	    	return Py_BuildValue("d",0.0);
	    }
		return Py_BuildValue("d",triaxial_ellipsoid_analytical_2D(&(self->model_pars),q_value,phi_value));

	} else {

		// We have a scalar q, we will evaluate I(q)
		q_value = CTriaxialEllipsoidModel_readDouble(pars);		
		
		return Py_BuildValue("d",triaxial_ellipsoid_analytical_1D(&(self->model_pars),q_value));
	}	
}

/**
 * Function to call to evaluate model in cartesian coordinates
 * @param args: input q or [qx, qy]]
 * @return: function value
 */
static PyObject * runXY(CTriaxialEllipsoidModel *self, PyObject *args) {
	double qx_value, qy_value;
	PyObject* pars;
	int npars;
	
	// Get parameters
	
	// Reader parameter dictionary
    self->model_pars.scale = PyFloat_AsDouble( PyDict_GetItemString(self->params, "scale") );
    self->model_pars.axis_psi = PyFloat_AsDouble( PyDict_GetItemString(self->params, "axis_psi") );
    self->model_pars.axis_theta = PyFloat_AsDouble( PyDict_GetItemString(self->params, "axis_theta") );
    self->model_pars.semi_axisA = PyFloat_AsDouble( PyDict_GetItemString(self->params, "semi_axisA") );
    self->model_pars.semi_axisB = PyFloat_AsDouble( PyDict_GetItemString(self->params, "semi_axisB") );
    self->model_pars.semi_axisC = PyFloat_AsDouble( PyDict_GetItemString(self->params, "semi_axisC") );
    self->model_pars.axis_phi = PyFloat_AsDouble( PyDict_GetItemString(self->params, "axis_phi") );
    self->model_pars.background = PyFloat_AsDouble( PyDict_GetItemString(self->params, "background") );
    self->model_pars.contrast = PyFloat_AsDouble( PyDict_GetItemString(self->params, "contrast") );

	
	// Get input and determine whether we have to supply a 1D or 2D return value.
	if ( !PyArg_ParseTuple(args,"O",&pars) ) {
	    PyErr_SetString(CTriaxialEllipsoidModelError, 
	    	"CTriaxialEllipsoidModel.run expects a q value.");
		return NULL;
	}
	  
	// Check params
	if( PyList_Check(pars)==1) {
		
		// Length of list should be 2 for I(qx, qy))
	    npars = PyList_GET_SIZE(pars); 
	    if(npars!=2) {
	    	PyErr_SetString(CTriaxialEllipsoidModelError, 
	    		"CTriaxialEllipsoidModel.run expects a double or a list of dimension 2.");
	    	return NULL;
	    }
	    // We have a vector q, get the qx and qy values at which
	    // to evaluate I(qx,qy)
	    qx_value = CTriaxialEllipsoidModel_readDouble(PyList_GET_ITEM(pars,0));
	    qy_value = CTriaxialEllipsoidModel_readDouble(PyList_GET_ITEM(pars,1));
		return Py_BuildValue("d",triaxial_ellipsoid_analytical_2DXY(&(self->model_pars),qx_value,qy_value));

	} else {

		// We have a scalar q, we will evaluate I(q)
		qx_value = CTriaxialEllipsoidModel_readDouble(pars);		
		
		return Py_BuildValue("d",triaxial_ellipsoid_analytical_1D(&(self->model_pars),qx_value));
	}	
}

static PyObject * reset(CTriaxialEllipsoidModel *self, PyObject *args) {
    

    return Py_BuildValue("d",0.0);
}


static PyMethodDef CTriaxialEllipsoidModel_methods[] = {
    {"run",      (PyCFunction)run     , METH_VARARGS,
      "Evaluate the model at a given Q or Q, phi"},
    {"runXY",      (PyCFunction)runXY     , METH_VARARGS,
      "Evaluate the model at a given Q or Qx, Qy"},
    {"reset",    (PyCFunction)reset   , METH_VARARGS,
      "Reset pair correlation"},
    //{"numerical_1D",      (PyCFunction)numerical_1D     , METH_VARARGS,
    //  "Evaluate the 1D model at a given Q"},
   {NULL}
};

static PyTypeObject CTriaxialEllipsoidModelType = {
    PyObject_HEAD_INIT(NULL)
    0,                         /*ob_size*/
    "CTriaxialEllipsoidModel",             /*tp_name*/
    sizeof(CTriaxialEllipsoidModel),             /*tp_basicsize*/
    0,                         /*tp_itemsize*/
    (destructor)CTriaxialEllipsoidModel_dealloc, /*tp_dealloc*/
    0,                         /*tp_print*/
    0,                         /*tp_getattr*/
    0,                         /*tp_setattr*/
    0,                         /*tp_compare*/
    0,                         /*tp_repr*/
    0,                         /*tp_as_number*/
    0,                         /*tp_as_sequence*/
    0,                         /*tp_as_mapping*/
    0,                         /*tp_hash */
    0,                         /*tp_call*/
    0,                         /*tp_str*/
    0,                         /*tp_getattro*/
    0,                         /*tp_setattro*/
    0,                         /*tp_as_buffer*/
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE, /*tp_flags*/
    "CTriaxialEllipsoidModel objects",           /* tp_doc */
    0,		               /* tp_traverse */
    0,		               /* tp_clear */
    0,		               /* tp_richcompare */
    0,		               /* tp_weaklistoffset */
    0,		               /* tp_iter */
    0,		               /* tp_iternext */
    CTriaxialEllipsoidModel_methods,             /* tp_methods */
    CTriaxialEllipsoidModel_members,             /* tp_members */
    0,                         /* tp_getset */
    0,                         /* tp_base */
    0,                         /* tp_dict */
    0,                         /* tp_descr_get */
    0,                         /* tp_descr_set */
    0,                         /* tp_dictoffset */
    (initproc)CTriaxialEllipsoidModel_init,      /* tp_init */
    0,                         /* tp_alloc */
    CTriaxialEllipsoidModel_new,                 /* tp_new */
};


static PyMethodDef module_methods[] = {
    {NULL} 
};

/**
 * Function used to add the model class to a module
 * @param module: module to add the class to
 */ 
void addCTriaxialEllipsoidModel(PyObject *module) {
	PyObject *d;
	
    if (PyType_Ready(&CTriaxialEllipsoidModelType) < 0)
        return;

    Py_INCREF(&CTriaxialEllipsoidModelType);
    PyModule_AddObject(module, "CTriaxialEllipsoidModel", (PyObject *)&CTriaxialEllipsoidModelType);
    
    d = PyModule_GetDict(module);
    CTriaxialEllipsoidModelError = PyErr_NewException("CTriaxialEllipsoidModel.error", NULL, NULL);
    PyDict_SetItemString(d, "CTriaxialEllipsoidModelError", CTriaxialEllipsoidModelError);
}

